<!DOCTYPE html>
<html lang="en">

<head>
    <title>Dashboard - Dokumenta</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <link rel="icon" type="image/ico" href="{{ url_for('static', filename='favicon.ico') }}">

    <link rel="stylesheet" href="{{ url_for('static', filename='vendors/mdi/css/materialdesignicons.min.css') }}">
    <link rel="stylesheet" href="{{ url_for('static', filename='css/style.css') }}">
    <script src="{{ url_for('static', filename='js/redirection.js') }}"></script>
</head>

<body>
    <div class="container-scroller">
        <nav class="sidebar sidebar-offcanvas" id="sidebar">
            <div class="sidebar-brand-wrapper d-none d-lg-flex align-items-center justify-content-center fixed-top">
                <a class="sidebar-brand brand-logo" href="/"><img src="{{ url_for('static', filename='images/logo.svg') }}" alt="Logo"></a>
                <a class="sidebar-brand brand-logo-mini" href="/"><img src="{{ url_for('static', filename='images/logo-mini.svg') }}" alt="Logo Mini"></a>
            </div>
            <ul class="nav">
                <li class="nav-item nav-category">
                    <span class="nav-link">Navigation</span>
                </li>
                <li class="nav-item menu-items active">
                    <a class="nav-link" href="/">
                        <span class="menu-icon">
                            <i class="mdi mdi-speedometer"></i>
                        </span>
                        <span class="menu-title">Dashboard</span>
                    </a>
                </li>
                <li class="nav-item menu-items">
                    <a class="nav-link" href="/categories">
                        <span class="menu-icon">
                            <i class="mdi mdi-table-large"></i>
                        </span>
                        <span class="menu-title">Categories</span>
                    </a>
                </li>
                <li class="nav-item menu-items">
                    <a class="nav-link" href="/documents">
                        <span class="menu-icon">
                            <i class="mdi mdi-table-large"></i>
                        </span>
                        <span class="menu-title">Documents</span>
                    </a>
                </li>
                <li class="nav-item menu-items">
                    <a class="nav-link" href="/users">
                        <span class="menu-icon">
                            <i class="mdi mdi-table-large"></i>
                        </span>
                        <span class="menu-title">Users</span>
                    </a>
                </li>
                <li class="nav-item menu-items">
                    <a class="nav-link" href="/docs/v1" target="_blank">
                        <span class="menu-icon">
                            <i class="mdi mdi-file-document-box"></i>
                        </span>
                        <span class="menu-title">API Documentation</span>
                    </a>
                </li>
            </ul>
        </nav>
        <div class="container-fluid page-body-wrapper">
            <nav class="navbar p-0 fixed-top d-flex flex-row">
                <div class="navbar-brand-wrapper d-flex d-lg-none align-items-center justify-content-center">
                    <a class="navbar-brand brand-logo-mini" href="/"><img src="{{ url_for('static', filename='images/logo-mini.svg') }}" alt="Logo Mini"></a>
                </div>
                <div class="navbar-menu-wrapper flex-grow d-flex align-items-stretch">
                    <button class="navbar-toggler navbar-toggler align-self-center" type="button" data-toggle="minimize">
                        <span class="mdi mdi-menu"></span>
                    </button>
                    <ul class="navbar-nav w-100"></ul>
                    <ul class="navbar-nav navbar-nav-right">
                        <li class="nav-item dropdown">
                            <a class="nav-link" id="profileDropdown" href="#" data-toggle="dropdown">
                                <div class="navbar-profile">
                                    <p class="mb-0 d-none d-sm-block navbar-profile-name" id="usernameTopRight">USERNAME</p>
                                    <i class="mdi mdi-menu-down d-none d-sm-block"></i>
                                </div>
                            </a>
                            <div class="dropdown-menu dropdown-menu-right navbar-dropdown preview-list" aria-labelledby="profileDropdown">
                                <a class="dropdown-item preview-item" id="logoutButton">
                                    <div class="preview-thumbnail">
                                        <div class="preview-icon bg-dark rounded-circle">
                                            <i class="mdi mdi-logout text-danger"></i>
                                        </div>
                                    </div>
                                    <div class="preview-item-content">
                                        <p class="preview-subject mb-1">Logout</p>
                                    </div>
                                </a>
                            </div>
                        </li>
                    </ul>
                    <button class="navbar-toggler navbar-toggler-right d-lg-none align-self-center" type="button" data-toggle="offcanvas">
                        <span class="mdi mdi-format-line-spacing"></span>
                    </button>
                </div>
            </nav>

            <div class="main-panel">
                <div class="content-wrapper">
                    <div class="row">
                        <div class="col-xl-3 col-sm-6 grid-margin stretch-card">
                            <div class="card">
                                <div class="card-body">
                                    <div class="row">
                                        <div class="col-9">
                                            <div class="d-flex align-items-center align-self-start">
                                                <h3 class="mb-0">{{ document_count }}</h3>
                                            </div>
                                        </div>
                                        <div class="col-3">
                                            <div class="icon icon-box-dark dashboard-icon">
                                                <img class="img-fluid" src="{{ url_for('static', filename='images/icons/document.png') }}">
                                            </div>
                                        </div>
                                    </div>
                                    <h6 class="text-muted font-weight-normal">Documents</h6>
                                </div>
                            </div>
                        </div>
                        <div class="col-xl-3 col-sm-6 grid-margin stretch-card">
                            <div class="card">
                                <div class="card-body">
                                    <div class="row">
                                        <div class="col-9">
                                            <div class="d-flex align-items-center align-self-start">
                                                <h3 class="mb-0">{{ category_count }}</h3>
                                            </div>
                                        </div>
                                        <div class="col-3">
                                            <div class="icon icon-box-dark dashboard-icon">
                                                <img class="img-fluid" src="{{ url_for('static', filename='images/icons/discovered-categories.png') }}">
                                            </div>
                                        </div>
                                    </div>
                                    <h6 class="text-muted font-weight-normal">Discovered Categories</h6>
                                </div>
                            </div>
                        </div>
                        <div class="col-xl-3 col-sm-6 grid-margin stretch-card">
                            <div class="card">
                                <div class="card-body">
                                    <div class="row">
                                        <div class="col-9">
                                            <div class="d-flex align-items-center align-self-start">
                                                <h3 class="mb-0">{{ named_category_count }}</h3>
                                            </div>
                                        </div>
                                        <div class="col-3">
                                            <div class="icon icon-box-dark dashboard-icon">
                                                <img class="img-fluid" src="{{ url_for('static', filename='images/icons/named-categories.png') }}">
                                            </div>
                                        </div>
                                    </div>
                                    <h6 class="text-muted font-weight-normal">Named Categories</h6>
                                </div>
                            </div>
                        </div>
                        <div class="col-xl-3 col-sm-6 grid-margin stretch-card">
                            <div class="card">
                                <div class="card-body">
                                    <div class="row">
                                        <div class="col-9">
                                            <div class="d-flex align-items-center align-self-start">
                                                <h3 class="mb-0">{{ unnamed_category_count }}</h3>
                                            </div>
                                        </div>
                                        <div class="col-3">
                                            <div class="icon icon-box-dark dashboard-icon">
                                                <img class="img-fluid" src="{{ url_for('static', filename='images/icons/unnamed-categories.png') }}">
                                            </div>
                                        </div>
                                    </div>
                                    <h6 class="text-muted font-weight-normal">Unnamed Categories</h6>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-lg-6 col-md-12 mb-4">
                            <div class="card">
                                <div class="card-body">
                                    <h4 class="card-title">Documents Distribution (Category : depth = 1)</h4>
                                    <canvas id="barChart" style="height: 230px;"></canvas>
                                </div>
                            </div>
                        </div>
                        <div class="col-lg-6 col-md-12 mb-4" style="{{ '' if dc_when_clustering else 'display: none;' }}">
                            <div class="card">
                                <div class="card-body">
                                    <h4 class="card-title">Last Clustering</h4>

                                    <div class="mb-3" style="background-color: {{ clstrng_warning_color }};">&nbsp;</div>
                                    <p>
                                        Since the last clustering where there were {{ dc_when_clustering }} documents used to generate the categories, <span>{{ dc_since_clustering }}</span> documents have been added, or {{ dp_since_clustering }}%.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>

                <footer class="footer">
                    <div class="d-sm-flex justify-content-center justify-content-sm-between">
                        <span class="text-muted d-block text-center text-sm-left d-sm-inline-block">Copyright 2021 Florian Burgener</span>
                    </div>
                </footer>
            </div>
        </div>
    </div>

    {% include 'scripts.html' %}
    <script src="{{ url_for('static', filename='js/Chart.min.js') }}"></script>
    <script src="{{ url_for('static', filename='js/palette.js') }}"></script>
    <script>
        $(function () {
            /*
             * Converts a hexadecimal color to RGBA.
             *
             * @param {Object} hex The hexadecimal color.
             * @param {Object} The desired opacity.
             * @retrn An RGBA color.
             */
            function hexToRgbA(hex, opacity) {
                var c;
                if (/^#([A-Fa-f0-9]{3}){1,2}$/.test(hex)) {
                    c = hex.substring(1).split('');
                    if (c.length == 3) {
                        c = [c[0], c[0], c[1], c[1], c[2], c[2]];
                    }
                    c = '0x' + c.join('');
                    return 'rgba(' + [(c >> 16) & 255, (c >> 8) & 255, c & 255].join(',') + ',' + opacity + ')';
                }
                throw new Error('Bad Hex');
            }

            // // Sends the request to the API.
            axios.get('/api/v1/categories?with_tags=1').then(function (response) {
                var categories = response.data;
                categories = categories.filter(function (category) {
                    return category.category_id === null;
                })
                var labels = [];
                var values = [];

                for (var i in categories) {
                    var category = categories[i];
                    labels.push(category.name ? category.name : "Category #" + category.id);
                    values.push(category.document_count);
                }
                drawChart(labels, values);
            });

            /*
             * Draw the graph.
             *
             * @param {Object} labels Legends for the x axis of the graph.
             * @param {Object} values The images of all the points on the graph.
             */
            function drawChart(labels, values) {
                var data = {
                    labels: labels,
                    datasets: [{
                        label: 'Number of documents',
                        data: values,
                        backgroundColor: palette('tol-rainbow', values.length).map(function (hex) {
                            return hexToRgbA('#' + hex, 0.2);
                        }),
                        borderColor: palette('tol-rainbow', values.length).map(function (hex) {
                            return hexToRgbA('#' + hex, 1);
                        }),
                        borderWidth: 1,
                        fill: false,
                    }]
                };

                var options = {
                    scales: {
                        yAxes: [{
                            ticks: {
                                beginAtZero: true,
                            },
                            gridLines: {
                                color: "rgba(204, 204, 204,0.1)"
                            },
                            scaleLabel: {
                                display: true,
                                labelString: 'Number of documents'
                            },
                        }],
                        xAxes: [{
                            gridLines: {
                                color: "rgba(204, 204, 204,0.1)"
                            },
                            scaleLabel: {
                                display: true,
                                labelString: 'Category'
                            },
                        }]
                    },
                    legend: {
                        display: false
                    },
                    elements: {
                        point: {
                            radius: 0
                        }
                    }
                };

                var barChartCanvas = $("#barChart").get(0).getContext("2d");
                var barChart = new Chart(barChartCanvas, {
                    type: 'bar',
                    data: data,
                    options: options
                });
            }
        });

    </script>
</body>

</html>
